/*
 * Tudor Alexandra 333 CB
 * Proiect PM 2015
 * Masinuta controlata prin bluetooth
 */

#include <avr/io.h>
#include <util/delay.h>

void USART0_init() 
{
    /* seteaza baud rate la 38400 */
    UBRR0H = 0;
    UBRR0L = 103;

    /* porneste transmitatorul */
    UCSR0B = (1<<TXEN0) | (1<<RXEN0);

    /* seteaza formatul frame-ului: 8 biti de date, 1 bit de stop, fara paritate */
    UCSR0C = (3<<UCSZ00);
}

char USART0_receive() 
{
    /* asteapta cat timp bufferul e gol */
    while(!(UCSR0A & (1<<RXC0)));

    /* returneaza datele din buffer */
    return UDR0;
}

void auto_mode()
{
    ///stop
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);

    //mergi inainte
    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);
    _delay_ms(900);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
    
    //fa stanga
    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);

    PORTB &= ~(1 << PB4);
    PORTB |= (1 << PB3);
    _delay_ms(800);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
    
    //merg in spate
    PORTB &= ~(1 << PB5);
    PORTB |= (1 << PB6);
    _delay_ms(900);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
   
    // dreapta
    PORTB &= ~(1 << PB3);
    PORTB |= (1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB |= (1 << PB6);
    _delay_ms(800);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
   
    // inainte
    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);
    _delay_ms(900);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
    
    //mergi inainte
    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);
    _delay_ms(700);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
  
    //fa stanga
    PORTB &= ~(1 << PB4);
    PORTB |= (1 << PB3);

    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);
    _delay_ms(800);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
  
    //merg in spate
    PORTB &= ~(1 << PB5);
    PORTB |= (1 << PB6);
    _delay_ms(900);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
   
    // dreapta
    PORTB &= ~(1 << PB3);
    PORTB |= (1 << PB4);

    PORTB &= ~(1 << PB5);
    PORTB |= (1 << PB6);
    _delay_ms(800);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
  
    // inainte
    PORTB &= ~(1 << PB6);
    PORTB |= (1 << PB5);
    _delay_ms(600);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
}

void rock()
{
    /* Control motoare */
    DDRB |= (1 << PB3);
    DDRB |= (1 << PB4);
    DDRB |= (1 << PB5);
    DDRB |= (1 << PB6);

    /* Enable motoare */
    DDRB |= (1 << PB2);
    DDRB |= (1 << PB7);

    /* Clean */
    PORTB &= ~(1 << PB2);
    PORTB &= ~(1 << PB3);
    PORTB &= ~(1 << PB4);
    PORTB &= ~(1 << PB5);
    PORTB &= ~(1 << PB6);
    PORTB &= ~(1 << PB7);

    /* Setez pinii pentru enable motoare pe HIGH */
    PORTB |= (1 << PB2);
    PORTB |= (1 << PB7);

    char c;

    for(;;)
    {
        /* Opreste toate motoarele */
        PORTB &= ~(1 << PB3);
        PORTB &= ~(1 << PB4);
        PORTB &= ~(1 << PB5);
        PORTB &= ~(1 << PB6);
        
        c = USART0_receive();

        switch(c)
        {
            case 'U':
                /* Motor inainte */
                PORTB &= ~(1 << PB6);
                PORTB |= (1 << PB5);
				break;
            case 'D':
                /* Motor inapoi */
                PORTB &= ~(1 << PB5);
                PORTB |= (1 << PB6);
                break;
            case 'L':
                /* Motor la stanga */
                PORTB &= ~(1 << PB4);
                PORTB |= (1 << PB3);
                break;
            case 'R':
                /* Motor la dreapta */
                PORTB &= ~(1 << PB3);
                PORTB |= (1 << PB4);
                break;
            case 'S':
                /* Opreste toate motoarele */
                PORTB &= ~(1 << PB3);
                PORTB &= ~(1 << PB4);
                PORTB &= ~(1 << PB5);
                PORTB &= ~(1 << PB6);
                break;
            case 'A':
                auto_mode();
                break;
        }
        _delay_ms(300);

    }
}

int main()
{
    USART0_init();

    rock();
	
    return 0;
}

